### Xilinx Processor IP Library

<hl>Software Drivers</hl>

Main Page | Data Structures | File List | Globals

# xgpio.h File Reference

## Detailed Description

## Data Structures

struct | XGpio_Config
struct | XGpio

## Functions

int | XGpio_Initialize (XGpio *InstancePtr, u16 DeviceId)
XGpio_Config * | XGpio_LookupConfig (u16 DeviceId)
int | XGpio_CfgInitialize (XGpio *InstancePtr, XGpio_Config *Config, u32 EffectiveAddr)
void | XGpio_SetDataDirection (XGpio *InstancePtr, unsigned Channel, u32 DirectionMask)
u32 | XGpio_GetDataDirection (XGpio *InstancePtr, unsigned Channel)
u32 | XGpio_DiscreteRead (XGpio *InstancePtr, unsigned Channel)
void | XGpio_DiscreteWrite (XGpio *InstancePtr, unsigned Channel, u32 Mask)
void | XGpio_DiscreteSet (XGpio *InstancePtr, unsigned Channel, u32 Mask)
void | XGpio_DiscreteClear (XGpio *InstancePtr, unsigned Channel, u32 Mask)
int | XGpio_SelfTest (XGpio *InstancePtr)
void | XGpio_InterruptGlobalEnable (XGpio *InstancePtr)
void | XGpio_InterruptGlobalDisable (XGpio *InstancePtr)
void | XGpio_InterruptEnable (XGpio *InstancePtr, u32 Mask)
void | XGpio_InterruptDisable (XGpio *InstancePtr, u32 Mask)
void | XGpio_InterruptClear (XGpio *InstancePtr, u32 Mask)
u32 | XGpio_InterruptGetEnabled (XGpio *InstancePtr)
u32 | XGpio_InterruptGetStatus (XGpio *InstancePtr)

## Function Documentation

int XGpio_CfgInitialize | ( | XGpio * | InstancePtr,
|  | XGpio_Config * | Config,
|  | u32 | EffectiveAddr
| ) |

Initialize the XGpio instance provided by the caller based on the given configuration data.

Nothing is done except to initialize the InstancePtr.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance. The memory the pointer references must be pre-allocated by the caller. Further calls to manipulate the component through the XGpio API must be made with this pointer.
  | Config | is a reference to a structure containing information about a specific GPIO device. This function initializes an InstancePtr object for a specific device specified by the contents of Config. This function can initialize multiple instance objects with the use of multiple calls giving different Config information on each call.

  EffectiveAddr

  is the device base address in the virtual memory address space. The caller is responsible for keeping the address mapping from EffectiveAddr to the device physical base address unchanged once this function is invoked. Unexpected errors may occur if the address mapping changes after this function is called. If address translation is not used, use Config->BaseAddress for this parameters, passing the physical address instead.

Returns:
  - XST_SUCCESS Initialization was successfull.

Note:
  None.

void XGpio_DiscreteClear | ( | XGpio * | InstancePtr,
|  | unsigned | Channel,
|  | u32 | Mask
| ) |

Set output discrete(s) to logic 0 for the specified GPIO channel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.
  | Mask | is the set of bits that will be set to 0 in the discrete data register. All other bits in the data register are unaffected.

Returns:
  None.

Note:

The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert.

u32 XGpio_DiscreteRead | ( | XGpio * | InstancePtr,
|  | unsigned | Channel
| ) |

Read state of discretes for the specified GPIO channnel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.

Returns:
  Current copy of the discretes register.

Note:
  The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert.

void XGpio_DiscreteSet | ( | XGpio * | InstancePtr,
|  | unsigned | Channel,
|  | u32 | Mask
| ) |

Set output discrete(s) to logic 1 for the specified GPIO channel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.
  | Mask | is the set of bits that will be set to 1 in the discrete data register. All other bits in the data register are unaffected.

Returns:
  None.

Note:

The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert.

void XGpio_DiscreteWrite | ( | XGpio * | InstancePtr,
|  | unsigned | Channel,
|  | u32 | Data
| ) |

Write to discretes register for the specified GPIO channel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.
  | Data | is the value to be written to the discretes register.

Returns:
  None.

Note:
  The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert. See also XGpio_DiscreteSet() and XGpio_DiscreteClear().

u32 XGpio_GetDataDirection | ( | XGpio * | InstancePtr,
|  | unsigned | Channel
| ) |

Get the input/output direction of all discrete signals for the specified GPIO channel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.

Returns:
  Bitmask specifying which discretes are input and which are output. Bits set to 0 are output and bits set to 1 are input.

Note:

The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert.

int XGpio_Initialize | ( | XGpio * | InstancePtr,
|  | u16 | DeviceId
| ) |

Initialize the XGpio instance provided by the caller based on the given DeviceID.

Nothing is done except to initialize the InstancePtr.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance. The memory the pointer references must be pre-allocated by the caller. Further calls to manipulate the component through the XGpio API must be made with this pointer.
  | DeviceId | is the unique id of the device controlled by this XGpio component. Passing in a device id associates the generic XGpio instance to a specific device, as chosen by the caller or application developer.

Returns:
  - XST_SUCCESS if the initialization was successfull.
  - XST_DEVICE_NOT_FOUND if the device configuration data was not found for a device with the supplied device ID.

Note:
  None.

void XGpio_InterruptClear | ( | XGpio * | InstancePtr,
|  | u32 | Mask
| ) |

Clear pending interrupts with the provided mask. This function should be called after the software has serviced the interrupts that are pending. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.
  | Mask | is the mask to clear pending interrupts for. Bit positions of 1 are cleared. This mask is formed by OR'ing bits from XGPIO_IR* bits which are contained in xgpio_l.h.

Returns:
  None.

Note:
  None.

void XGpio_InterruptDisable | ( | XGpio * | InstancePtr,
|  | u32 | Mask
| ) |

Disable interrupts. This function allows specific interrupts for each channel to be disabled. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.
  | Mask | is the mask to disable. Bits set to 1 are disabled. This mask is formed by OR'ing bits from XGPIO_IR* bits which are contained in xgpio_l.h.

Returns:
  None.

Note:
  None.

void XGpio_InterruptEnable | ( | XGpio * | InstancePtr,
|  | u32 | Mask
| ) |

Enable interrupts. The global interrupt must also be enabled by calling XGpio_InterruptGlobalEnable() for interrupts to occur. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.
  | Mask | is the mask to enable. Bit positions of 1 are enabled. This mask is formed by OR'ing bits from XGPIO_IR* bits which are contained in xgpio_l.h.

Returns:
  None.

Note:
  None.

u32 XGpio_InterruptGetEnabled | ( | XGpio * | InstancePtr | ) |

Returns the interrupt enable mask. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.

Returns:
  A mask of bits made from XGPIO_IR* bits which are contained in xgpio_l.h.

  None.

Note:
  None.

u32 XGpio_InterruptGetStatus | ( | XGpio * | InstancePtr | ) |

Returns the status of interrupt signals. Any bit in the mask set to 1 indicates that the channel associated with the bit has asserted an interrupt condition. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.

Returns:
  A pointer to a mask of bits made from XGPIO_IR* bits which are contained in xgpio_l.h.

Note:

The interrupt status indicates the status of the device irregardless if the interrupts from the devices have been enabled or not through XGpio_InterruptEnable().

void XGpio_InterruptGlobalDisable | ( | XGpio * | InstancePtr | ) |

Disable the interrupt output signal. Interrupts enabled through XGpio_InterruptEnable() will no longer be passed through until the global enable bit is set by XGpio_InterruptGlobalEnable(). This function is designed to allow all interrupts (both channels) to be disabled easily for entering a critical section. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.

Returns:
  None.

Note:
  None.

void XGpio_InterruptGlobalEnable | ( | XGpio * | InstancePtr | ) |

Enable the interrupt output signal. Interrupts enabled through XGpio_InterruptEnable() will not be passed through until the global enable bit is set by this function. This function is designed to allow all interrupts (both channels) to be enabled easily for exiting a critical section. This function will assert if the hardware device has not been built with interrupt capabilities.

Parameters:

  | InstancePtr | is the GPIO component to operate on.

Returns:
  None.

Note:
  None.

XGpio_Config* XGpio_LookupConfig | ( | u16 | DeviceId | ) |

Lookup the device configuration based on the unique device ID. The table ConfigTable contains the configuration info for each device in the system.

Parameters:

  | DeviceId | is the device identifier to lookup.

Returns:
  - A pointer of data type XGpio_Config which points to the device configuration if DeviceID is found.

- NULL if DeviceID is not found.

Note:
  None.

int XGpio_SelfTest | ( | XGpio * | InstancePtr | ) |

Run a self-test on the driver/device. This function does a minimal test in which the data register is read. It only does a read without any kind of test because the hardware has been parameterized such that it may be only an input such that the state of the inputs won't be known.

All other hardware features of the device are not guaranteed to be in the hardware since they are parameterizable.

Parameters:

  | InstancePtr | is a pointer to the XGpio instance to be worked on. This parameter must have been previously initialized with XGpio_Initialize().

Returns:
  XST_SUCCESS always. If the GPIO device was not present in the hardware a bus error could be generated. Other indicators of a bus error, such as registers in bridges or buses, may be necessary to determine if this function caused a bus error.

Note:
  None.

void XGpio_SetDataDirection | ( | XGpio * | InstancePtr,
|  | unsigned | Channel,
|  | u32 | DirectionMask
| ) |

Set the input/output direction of all discrete signals for the specified GPIO channel.

Parameters:

  | InstancePtr | is a pointer to an XGpio instance to be worked on.
  | Channel | contains the channel of the GPIO (1 or 2) to operate on.
  | DirectionMask | is a bitmask specifying which discretes are input and which are output. Bits set to 0 are output and bits set to 1 are input.

Returns:
  None.

Note:
  The hardware must be built for dual channels if this function is used with any channel other than 1. If it is not, this function will assert.

Copyright © 1995-2009 Xilinx, Inc. All rights reserved.